diff --git a/utils/fpcm/fpcmake.inc b/utils/fpcm/fpcmake.inc
index 7a449ea737..e1e3022c2f 100644
--- a/utils/fpcm/fpcmake.inc
+++ b/utils/fpcm/fpcmake.inc
@@ -1,7 +1,7 @@
 {$ifdef Delphi}
-const fpcmakeini : array[0..247] of string[240]=(
+const fpcmakeini : array[0..249] of string[240]=(
 {$else Delphi}
-const fpcmakeini : array[0..247,1..240] of char=(
+const fpcmakeini : array[0..249,1..240] of char=(
 {$endif Delphi}
   ';'#010+
   '; Templates used by fpcmake to create a Makefile from Makefile.fpc'#010+
@@ -317,13 +317,29 @@ const fpcmakeini : array[0..247,1..240] of char=(
   'override FPCOPT+=-Cp$(SUBARCH)'#010+
   'endif'#010+
   #010+
+  'ifeq ($(FULL_TARGET),xtensa-freertos)'#010+
+  'ifeq ($(SUBARCH),)'#010+
+  '$(error When compiling for xtensa-freertos, a sub-architecture (e.g. S'+
+  'UBARCH=lx106 or SUBARCH=lx6) must be defined)'#010+
+  'endif'#010+
+  'overr','ide FPCOPT+=-Cp$(SUBARCH)'#010+
+  'endif'#010+
+  #010+
+  'ifeq ($(FULL_TARGET),arm-freertos)'#010+
+  'ifeq ($(SUBARCH),)'#010+
+  '$(error When compiling for arm-freertos, a sub-architecture (e.g. SUBA'+
+  'RCH=armv6m or SUBARCH=armv7em) must be defined)'#010+
+  'endif'#010+
+  'override FPCOPT+=-Cp$(SUBARCH',')'#010+
+  'endif'#010+
+  #010+
   '# Full name of the target, including CPU and OS. For OSs limited'#010+
   '# to 8.3 we only use the target OS'#010+
   'ifneq ($(findstring $(OS_SOURCE),$(LIMIT83fs)),)'#010+
   'TARGETSUFFIX=$(OS_TARGET)'#010+
-  'SOURCESUF','FIX=$(OS_SOURCE)'#010+
+  'SOURCESUFFIX=$(OS_SOURCE)'#010+
   'else'#010+
-  'ifneq ($(findstring $(OS_TARGET),$(LIMIT83fs)),)'#010+
+  'ifneq ($(findstring $(OS_','TARGET),$(LIMIT83fs)),)'#010+
   'TARGETSUFFIX=$(OS_TARGET)'#010+
   'else'#010+
   'TARGETSUFFIX=$(FULL_TARGET)'#010+
@@ -333,15 +349,15 @@ const fpcmakeini : array[0..247,1..240] of char=(
   #010+
   '# Cross compile flag'#010+
   'ifneq ($(FULL_TARGET),$(FULL_SOURCE))'#010+
-  'CROSSCOMPI','LE=1'#010+
+  'CROSSCOMPILE=1'#010+
   'endif'#010+
   #010+
-  '# Check if the Makefile supports this target, but not'#010+
+  '# Check if the Makefile supports th','is target, but not'#010+
   '# when the make target is to rebuild the makefile'#010+
   'ifeq ($(findstring makefile,$(MAKECMDGOALS)),)'#010+
   'ifeq ($(findstring $(FULL_TARGET),$(MAKEFILETARGETS)),)'#010+
-  '$(error The Makefile ','doesn'#039't support target $(FULL_TARGET), plea'+
-  'se run fpcmake first)'#010+
+  '$(error The Makefile doesn'#039't support target $(FULL_TARGET), please'+
+  ' r','un fpcmake first)'#010+
   'endif'#010+
   'endif'#010+
   #010+
@@ -352,8 +368,8 @@ const fpcmakeini : array[0..247,1..240] of char=(
   'BSDhier=1'#010+
   'endif'#010+
   #010+
-  '# Detect Linux, will also use',' its own directory hierarchy.'#010+
-  'ifeq ($(OS_TARGET),linux)'#010+
+  '# Detect Linux, will also use its own directory hierarchy.'#010+
+  'ifeq ($(OS_TARGET','),linux)'#010+
   'linuxHier=1'#010+
   'endif'#010+
   #010+
@@ -367,53 +383,52 @@ const fpcmakeini : array[0..247,1..240] of char=(
   'export BUILDNATIVE'#010+
   'endif'#010+
   #010+
-  'export OS_TARGET OS_SOURCE ARCH CPU','_TARGET CPU_SOURCE FULL_TARGET FU'+
-  'LL_SOURCE TARGETSUFFIX SOURCESUFFIX CROSSCOMPILE'#010+
+  'export OS_TARGET OS_SOURCE ARCH CPU_TARGET CPU_SOURCE FULL_TARGET FULL'+
+  '_SOURCE TARG','ETSUFFIX SOURCESUFFIX CROSSCOMPILE'#010+
   #010+
   '[fpmakefpcdetect]'#010+
   '#####################################################################'#010+
   '# FPC Binary and Version Detection'#010+
-  '##################################','##################################'+
-  '#'#010+
-  '# If FPCFPMAKE is not set and we'#039're cross-compiling, try to find a'+
-  #010+
+  '#####################################################################'#010+
+  '# If FPCFPM','AKE is not set and we'#039're cross-compiling, try to find'+
+  ' a'#010+
   '# native compiler.'#010+
   'ifndef FPCFPMAKE'#010+
   #010+
   'ifdef CROSSCOMPILE'#010+
   '# Search for the (native) ppc compiler which is used to do the latest '+
   'build'#010+
-  '# of ','the native rtl'#010+
+  '# of the native rtl'#010+
   #010+
-  'ifeq ($(strip $(wildcard $(addsuffix /compiler/ppc$(SRCEXEEXT),$(FPCDI'+
-  'R)))),)'#010+
+  'ifeq ($(strip $(wildcard $(adds','uffix /compiler/ppc$(SRCEXEEXT),$(FPC'+
+  'DIR)))),)'#010+
   '# If that compiler is not found, use the common, installed native comp'+
   'iler'#010+
   '# Note that in this case FPCFPMAKE is not exported, because it could b'+
-  'e',' that'#010+
-  '# a more suitable compiler is compiled later on'#010+
+  'e that'#010+
+  '# a more suitable compiler is compiled la','ter on'#010+
   '# check if fpc exists'#010+
   'FPCPROG:=$(strip $(wildcard $(addsuffix /fpc$(SRCEXEEXT),$(SEARCHPATH)'+
   ')))'#010+
   'ifneq ($(FPCPROG),)'#010+
   'FPCPROG:=$(firstword $(FPCPROG))'#010+
   'FPCFPMAKE:=$(shell $(FPCPROG) -PB)'#010+
-  '# ','if a native compiler is not found, fall back to fpc'#010+
+  '# if a native compiler is not found, fall back to',' fpc'#010+
   'ifeq ($(strip $(wildcard $(FPCFPMAKE))),)'#010+
   'FPCFPMAKE:=$(firstword $(FPCPROG))'#010+
   'endif'#010+
   'else'#010+
   '# fpc binary not found, fallback to ppc386'#010+
-  'override FPCFPMAKE=$(firstword $(strip $(wildcard $(addsu','ffix /ppc38'+
-  '6$(SRCEXEEXT),$(SEARCHPATH)))))'#010+
-  'endif'#010+
+  'override FPCFPMAKE=$(firstword $(strip $(wildcard $(addsuffix /ppc386$'+
+  '(SRCEXEEXT),$(SEARCHPATH)))))'#010+
+  'endi','f'#010+
   'else'#010+
   '# Use the ppc compiler. Because the path to the compiler is relative, '+
   'do not'#010+
   '# evaluate the variable here, but do that on the fly.'#010+
-  'FPCFPMAKE=$(strip $(wildcard $(addsuffix /compiler/ppc$','(SRCEXEEXT),$'+
-  '(FPCDIR))))'#010+
-  'FPMAKE_SKIP_CONFIG=-n'#010+
+  'FPCFPMAKE=$(strip $(wildcard $(addsuffix /compiler/ppc$(SRCEXEEXT),$(F'+
+  'PCDIR))))'#010+
+  'FPMAKE_SKIP_CONFIG=-n'#010,
   'export FPCFPMAKE'#010+
   'export FPMAKE_SKIP_CONFIG'#010+
   'endif'#010+
@@ -427,19 +442,19 @@ const fpcmakeini : array[0..247,1..240] of char=(
   #010+
   #010+
   '[fpcdircheckenv]'#010+
-  '###################################################################','#'+
-  '#'#010+
-  '# FPCDIR Setting'#010+
   '#####################################################################'#010+
+  '# FPCDIR Setting'#010+
+  '###########################','#########################################'+
+  '#'#010+
   #010+
   '# Test FPCDIR to look if the RTL dir exists'#010+
   'ifdef FPCDIR'#010+
   'override FPCDIR:=$(subst \,/,$(FPCDIR))'#010+
   'ifeq ($(wildcard $(addprefix $(FPCDIR)/,rtl)),)'#010+
-  'over','ride FPCDIR=wrong'#010+
+  'override FPCDIR=wrong'#010+
   'endif'#010+
   'else'#010+
-  'override FPCDIR=wrong'#010+
+  'override FPCDIR=wr','ong'#010+
   'endif'#010+
   #010+
   '# Default FPCDIR from Makefile.fpc'#010+
@@ -447,12 +462,12 @@ const fpcmakeini : array[0..247,1..240] of char=(
   'ifeq ($(FPCDIR),wrong)'#010+
   'override FPCDIR:=$(subst \,/,$(DEFAULT_FPCDIR))'#010+
   'ifeq ($(wildcard $(addprefix $(FPCDIR)/,rtl)),)'#010+
-  'overrid','e FPCDIR=wrong'#010+
+  'override FPCDIR=wrong'#010+
   'endif'#010+
   'endif'#010+
   'endif'#010+
   #010+
-  '[fpcdirdetect]'#010+
+  '[fpcdirdetect',']'#010+
   '# Detect FPCDIR'#010+
   'ifeq ($(FPCDIR),wrong)'#010+
   'ifdef inUnix'#010+
@@ -460,14 +475,14 @@ const fpcmakeini : array[0..247,1..240] of char=(
   'ifeq ($(wildcard $(FPCDIR)/units),)'#010+
   'override FPCDIR=/usr/lib/fpc/$(FPC_VERSION)'#010+
   'endif'#010+
-  'els','e'#010+
-  'override FPCDIR:=$(subst /$(FPC),,$(firstword $(strip $(wildcard $(add'+
-  'suffix /$(FPC),$(SEARCHPATH))))))'#010+
+  'else'#010+
+  'override FPCDIR:=$(subst /$(FPC),,$(firstword',' $(strip $(wildcard $(a'+
+  'ddsuffix /$(FPC),$(SEARCHPATH))))))'#010+
   'override FPCDIR:=$(FPCDIR)/..'#010+
   'ifeq ($(wildcard $(addprefix $(FPCDIR)/,rtl)),)'#010+
   'override FPCDIR:=$(FPCDIR)/..'#010+
-  'ifeq ($(wildcard $(addpref','ix $(FPCDIR)/,rtl)),)'#010+
-  'override FPCDIR:=$(BASEDIR)'#010+
+  'ifeq ($(wildcard $(addprefix $(FPCDIR)/,rtl)),)'#010+
+  'override FPCDIR:=$(BASEDI','R)'#010+
   'ifeq ($(wildcard $(addprefix $(FPCDIR)/,rtl)),)'#010+
   'override FPCDIR=c:/pp'#010+
   'endif'#010+
@@ -478,10 +493,10 @@ const fpcmakeini : array[0..247,1..240] of char=(
   #010+
   '# Cross binaries dir'#010+
   'ifndef CROSSBINDIR'#010+
-  'CROSSBINDIR:=$(wildcard $(FPCDIR)/bin/$(TARGETSUF','FIX))'#010+
+  'CROSSBINDIR:=$(wildcard $(FPCDIR)/bin/$(TARGETSUFFIX))'#010+
   'endif'#010+
   #010+
-  '# Default binutils prefix for cross compile when the'#010+
+  '# Default binutils prefix for cros','s compile when the'#010+
   '# crossbindir is not set (except for Darwin)'#010+
   'ifneq ($(findstring $(OS_TARGET),darwin iphonesim),)'#010+
   'ifeq ($(OS_SOURCE),darwin)'#010+
@@ -489,18 +504,18 @@ const fpcmakeini : array[0..247,1..240] of char=(
   'endif'#010+
   'endif'#010+
   #010+
-  'ifndef BINUTILSPREFI','X'#010+
+  'ifndef BINUTILSPREFIX'#010+
   'ifndef CROSSBINDIR'#010+
   'ifdef CROSSCOMPILE'#010+
-  'ifneq ($(OS_TARGET),msdos)'#010+
+  'ifneq (','$(OS_TARGET),msdos)'#010+
   'ifndef DARWIN2DARWIN'#010+
   'ifneq ($(CPU_TARGET),jvm)'#010+
   'BINUTILSPREFIX=$(CPU_TARGET)-$(OS_TARGET)-'#010+
   #010+
   '# For Android use standard NDK prefixes'#010+
   'ifeq ($(OS_TARGET),android)'#010+
-  'ifeq ($(CPU_TA','RGET),arm)'#010+
-  'BINUTILSPREFIX=arm-linux-androideabi-'#010+
+  'ifeq ($(CPU_TARGET),arm)'#010+
+  'BINUTILSPREFIX=arm-linux-androideabi','-'#010+
   'else'#010+
   'ifeq ($(CPU_TARGET),i386)'#010+
   'BINUTILSPREFIX=i686-linux-android-'#010+
@@ -515,19 +530,19 @@ const fpcmakeini : array[0..247,1..240] of char=(
   'else'#010+
   'BINUTILSPREFIX=$(OS_TARGET)-'#010+
   'endif'#010+
-  'endif',#010+
+  'endif'#010+
   'endif'#010+
   'endif'#010+
   #010+
-  '# Try first the full target name, otherwise try only'#010+
+  '# Try first the full target name,',' otherwise try only'#010+
   '# the OS for backwards compatibility'#010+
   'UNITSDIR:=$(wildcard $(FPCDIR)/units/$(TARGETSUFFIX))'#010+
   'ifeq ($(UNITSDIR),)'#010+
   'UNITSDIR:=$(wildcard $(FPCDIR)/units/$(OS_TARGET))'#010+
   'endif'#010+
   #010+
-  '# Pa','ckages dir'#010+
-  'PACKAGESDIR:=$(wildcard $(FPCDIR) $(FPCDIR)/packages)'#010+
+  '# Packages dir'#010+
+  'PACKAGESDIR:=$(wildcard $(FPCDIR) $(','FPCDIR)/packages)'#010+
   #010+
   #010+
   '[shelltools]'#010+
@@ -535,7 +550,7 @@ const fpcmakeini : array[0..247,1..240] of char=(
   '# Shell tools'#010+
   '#####################################################################'#010+
   #010+
-  '# Ech','o that can redir (must be able run in the default OS shell)'#010+
+  '# Echo that can redir (must be able run in the defau','lt OS shell)'#010+
   'ifndef ECHOREDIR'#010+
   'ifndef inUnix'#010+
   'ECHOREDIR=echo'#010+
@@ -551,10 +566,10 @@ const fpcmakeini : array[0..247,1..240] of char=(
   #010+
   '# Copy a whole tree'#010+
   'ifndef COPYTREE'#010+
-  'COPYT','REE:=$(CPPROG) -Rfp'#010+
+  'COPYTREE:=$(CPPROG) -Rfp'#010+
   'endif'#010+
   #010+
-  '# Copy a whole tree'#010+
+  '# Copy a whole tree'#010,
   'ifndef MKDIRTREE'#010+
   'MKDIRTREE:=$(MKDIRPROG) -p'#010+
   'endif'#010+
@@ -570,11 +585,11 @@ const fpcmakeini : array[0..247,1..240] of char=(
   'endif'#010+
   #010+
   '# Check deltree program'#010+
-  'ifn','def DELTREE'#010+
+  'ifndef DELTREE'#010+
   'DELTREE:=$(RMPROG) -rf'#010+
   'endif'#010+
   #010+
-  '# To install files'#010+
+  '# To ','install files'#010+
   'ifndef INSTALL'#010+
   'ifdef inUnix'#010+
   'INSTALL:=$(GINSTALL) -c -m 644'#010+
@@ -586,13 +601,13 @@ const fpcmakeini : array[0..247,1..240] of char=(
   '# To install programs'#010+
   'ifndef INSTALLEXE'#010+
   'ifdef inUnix'#010+
-  'INSTALLEXE:=$(GINSTALL) -c -m 75','5'#010+
+  'INSTALLEXE:=$(GINSTALL) -c -m 755'#010+
   'else'#010+
   'INSTALLEXE:=$(COPY)'#010+
   'endif'#010+
   'endif'#010+
   #010+
-  '# To make a directory.'#010+
+  '# To ma','ke a directory.'#010+
   'ifndef MKDIR'#010+
   'MKDIR:=$(GINSTALL) -m 755 -d'#010+
   'endif'#010+
@@ -602,9 +617,8 @@ const fpcmakeini : array[0..247,1..240] of char=(
   #010+
   #010+
   '[defaultdirs]'#010+
-  '#######################################','#############################'+
-  '#'#010+
-  '# Default Directories'#010+
+  '#####################################################################'#010+
+  '# Default Direct','ories'#010+
   '#####################################################################'#010+
   #010+
   '# Units dir'#010+
@@ -613,8 +627,8 @@ const fpcmakeini : array[0..247,1..240] of char=(
   'endif'#010+
   #010+
   '# Units dir'#010+
-  'ifdef REQUIRE_PACKAGESD','IR'#010+
-  'override PACKAGESDIR+=$(REQUIRE_PACKAGESDIR)'#010+
+  'ifdef REQUIRE_PACKAGESDIR'#010+
+  'override PACKAGESDIR+=$(REQUIRE_PACKAGESDIR)',#010+
   'endif'#010+
   #010+
   #010+
@@ -623,8 +637,8 @@ const fpcmakeini : array[0..247,1..240] of char=(
   '# use the source os as default'#010+
   'ifdef ZIPINSTALL'#010+
   '# Zipinstall'#010+
-  'ifneq ($(','findstring $(OS_TARGET),$(UNIXs)),)'#010+
-  'UNIXHier=1'#010+
+  'ifneq ($(findstring $(OS_TARGET),$(UNIXs)),)'#010+
+  'UNIXHier=1'#010,
   'endif'#010+
   'else'#010+
   '# Normal install'#010+
@@ -636,11 +650,11 @@ const fpcmakeini : array[0..247,1..240] of char=(
   '# When install prefix is not set try to use prefix'#010+
   'ifndef INSTALL_PREFIX'#010+
   'ifdef PREFIX'#010+
-  'INSTALL_PR','EFIX=$(PREFIX)'#010+
+  'INSTALL_PREFIX=$(PREFIX)'#010+
   'endif'#010+
   'endif'#010+
   #010+
-  '# set the prefix directory where to install everything'#010+
+  '# set the prefix di','rectory where to install everything'#010+
   'ifndef INSTALL_PREFIX'#010+
   'ifdef UNIXHier'#010+
   'INSTALL_PREFIX=/usr/local'#010+
@@ -649,32 +663,32 @@ const fpcmakeini : array[0..247,1..240] of char=(
   'INSTALL_BASEDIR:=/pp'#010+
   'else'#010+
   'INSTALL_BASEDIR:=/$(PACKAGE_NAME)'#010+
-  'endi','f'#010+
+  'endif'#010+
   'endif'#010+
   'endif'#010+
   'export INSTALL_PREFIX'#010+
   #010+
-  '# Export also INSTALL_SOURCESUBDIR set so it will be'#010+
+  '# Export a','lso INSTALL_SOURCESUBDIR set so it will be'#010+
   '# used recursively for all subdirs'#010+
   'ifdef INSTALL_FPCSUBDIR'#010+
   'export INSTALL_FPCSUBDIR'#010+
   'endif'#010+
   #010+
   '# Where to place the resulting zip files'#010+
-  'ifndef DIST_DESTDI','R'#010+
+  'ifndef DIST_DESTDIR'#010+
   'DIST_DESTDIR:=$(BASEDIR)'#010+
   'endif'#010+
-  'export DIST_DESTDIR'#010+
+  'export DIST_DE','STDIR'#010+
   #010+
   '# EXE/PPU Target directories'#010+
   'ifndef COMPILER_UNITTARGETDIR'#010+
   'ifdef PACKAGEDIR_MAIN'#010+
   'COMPILER_UNITTARGETDIR=$(PACKAGEDIR_MAIN)/units/$(TARGETSUFFIX)'#010+
   'else'#010+
-  'COMPILER_UNITTARGETDIR=units/$(TARGE','TSUFFIX)'#010+
+  'COMPILER_UNITTARGETDIR=units/$(TARGETSUFFIX)'#010+
   'endif'#010+
   'endif'#010+
-  'ifndef COMPILER_TARGETDIR'#010+
+  'ifndef COMPILER_TARGETDIR'#010,
   'COMPILER_TARGETDIR=.'#010+
   'endif'#010+
   #010+
@@ -683,7 +697,7 @@ const fpcmakeini : array[0..247,1..240] of char=(
   '# Install Directories'#010+
   '#####################################################################'#010+
   #010+
-  '#',' set the base directory where to install everything'#010+
+  '# set the base directory where to install everyt','hing'#010+
   'ifndef INSTALL_BASEDIR'#010+
   'ifdef UNIXHier'#010+
   'ifdef INSTALL_FPCPACKAGE'#010+
@@ -691,10 +705,10 @@ const fpcmakeini : array[0..247,1..240] of char=(
   'else'#010+
   'INSTALL_BASEDIR:=$(INSTALL_PREFIX)/lib/$(PACKAGE_NAME)'#010+
   'endif'#010+
-  'e','lse'#010+
+  'else'#010+
   'INSTALL_BASEDIR:=$(INSTALL_PREFIX)'#010+
   'endif'#010+
-  'endif'#010+
+  'en','dif'#010+
   #010+
   '# set the directory where to install the binaries'#010+
   'ifndef INSTALL_BINDIR'#010+
@@ -702,7 +716,7 @@ const fpcmakeini : array[0..247,1..240] of char=(
   'INSTALL_BINDIR:=$(INSTALL_PREFIX)/bin'#010+
   'else'#010+
   'INSTALL_BINDIR:=$(INSTALL_BASEDIR)/bin'#010+
-  '# for FPC packages ','install the binaries under their target subdir'#010+
+  '# for FPC packages install the binaries under their target subdir'#010,
   'ifdef INSTALL_FPCPACKAGE'#010+
   'ifdef CROSSCOMPILE'#010+
   'ifdef CROSSINSTALL'#010+
@@ -711,9 +725,9 @@ const fpcmakeini : array[0..247,1..240] of char=(
   'INSTALL_BINDIR:=$(INSTALL_BINDIR)/$(TARGETSUFFIX)'#010+
   'endif'#010+
   'else'#010+
-  'INSTALL_BINDIR',':=$(INSTALL_BINDIR)/$(TARGETSUFFIX)'#010+
-  'endif'#010+
+  'INSTALL_BINDIR:=$(INSTALL_BINDIR)/$(TARGETSUFFIX)'#010+
   'endif'#010+
+  'endif',#010+
   'endif'#010+
   'endif'#010+
   #010+
@@ -722,8 +736,8 @@ const fpcmakeini : array[0..247,1..240] of char=(
   'INSTALL_UNITDIR:=$(INSTALL_BASEDIR)/units/$(TARGETSUFFIX)'#010+
   'ifdef INSTALL_FPCPACKAGE'#010+
   'ifdef PACKAGE_NAME'#010+
-  'INSTAL','L_UNITDIR:=$(INSTALL_UNITDIR)/$(PACKAGE_NAME)'#010+
-  'endif'#010+
+  'INSTALL_UNITDIR:=$(INSTALL_UNITDIR)/$(PACKAGE_NAME)'#010+
+  'e','ndif'#010+
   'endif'#010+
   'endif'#010+
   #010+
@@ -736,8 +750,8 @@ const fpcmakeini : array[0..247,1..240] of char=(
   'endif'#010+
   'endif'#010+
   #010+
-  '# Where the',' source files will be stored'#010+
-  'ifndef INSTALL_SOURCEDIR'#010+
+  '# Where the source files will be stored'#010+
+  'ifndef INSTALL_SOU','RCEDIR'#010+
   'ifdef UNIXHier'#010+
   'ifdef BSDhier'#010+
   'SRCPREFIXDIR=share/src'#010+
@@ -750,15 +764,15 @@ const fpcmakeini : array[0..247,1..240] of char=(
   'endif'#010+
   'ifdef INSTALL_FPCPACKAGE'#010+
   'ifdef INSTALL_FPCSUBDIR'#010+
-  'INSTALL','_SOURCEDIR:=$(INSTALL_PREFIX)/$(SRCPREFIXDIR)/fpc-$(FPC_VERSI'+
+  'INSTALL_SOURCEDIR:=$(INSTALL_PREFIX)/$(SRCPREFIXDIR)/f','pc-$(FPC_VERSI'+
   'ON)/$(INSTALL_FPCSUBDIR)/$(PACKAGE_NAME)'#010+
   'else'#010+
   'INSTALL_SOURCEDIR:=$(INSTALL_PREFIX)/$(SRCPREFIXDIR)/fpc-$(FPC_VERSION'+
   ')/$(PACKAGE_NAME)'#010+
   'endif'#010+
   'else'#010+
-  'INSTALL_SOURCEDIR:=$(INSTALL_PREFI','X)/$(SRCPREFIXDIR)/$(PACKAGE_NAME)'+
-  '-$(PACKAGE_VERSION)'#010+
+  'INSTALL_SOURCEDIR:=$(INSTALL_PREFIX)/$(SRCPREFIXDIR)/$(PACKAGE_NAME)-$'+
+  '(PACKAGE_VE','RSION)'#010+
   'endif'#010+
   'else'#010+
   'ifdef INSTALL_FPCPACKAGE'#010+
@@ -766,10 +780,10 @@ const fpcmakeini : array[0..247,1..240] of char=(
   'INSTALL_SOURCEDIR:=$(INSTALL_BASEDIR)/source/$(INSTALL_FPCSUBDIR)/$(PA'+
   'CKAGE_NAME)'#010+
   'else'#010+
-  'INSTALL_SOURCEDIR:=$(INSTALL_BASEDIR)/s','ource/$(PACKAGE_NAME)'#010+
+  'INSTALL_SOURCEDIR:=$(INSTALL_BASEDIR)/source/$(PACKAGE_NAME)'#010+
   'endif'#010+
   'else'#010+
-  'INSTALL_SOURCEDIR:=$(INSTALL_BASEDIR)/source'#010+
+  'INSTALL_SOURCE','DIR:=$(INSTALL_BASEDIR)/source'#010+
   'endif'#010+
   'endif'#010+
   'endif'#010+
@@ -781,21 +795,21 @@ const fpcmakeini : array[0..247,1..240] of char=(
   'DOCPREFIXDIR=share/doc'#010+
   'else'#010+
   'ifdef linuxHier'#010+
-  'DOCPREFIXDI','R=share/doc'#010+
+  'DOCPREFIXDIR=share/doc'#010+
   'else'#010+
   'DOCPREFIXDIR=doc'#010+
   'endif'#010+
   'endif'#010+
-  'ifdef INSTALL_FPCPACKAGE'#010+
+  'i','fdef INSTALL_FPCPACKAGE'#010+
   'INSTALL_DOCDIR:=$(INSTALL_PREFIX)/$(DOCPREFIXDIR)/fpc-$(FPC_VERSION)/$'+
   '(PACKAGE_NAME)'#010+
   'else'#010+
   'INSTALL_DOCDIR:=$(INSTALL_PREFIX)/$(DOCPREFIXDIR)/$(PACKAGE_NAME)-$(PA'+
-  'CKAGE_VER','SION)'#010+
+  'CKAGE_VERSION)'#010+
   'endif'#010+
   'else'#010+
   'ifdef INSTALL_FPCPACKAGE'#010+
-  'INSTALL_DOCDIR:=$(INSTALL_BASEDIR)/doc/$(PACKAGE_NAME)'#010+
+  'INSTA','LL_DOCDIR:=$(INSTALL_BASEDIR)/doc/$(PACKAGE_NAME)'#010+
   'else'#010+
   'INSTALL_DOCDIR:=$(INSTALL_BASEDIR)/doc'#010+
   'endif'#010+
@@ -803,8 +817,8 @@ const fpcmakeini : array[0..247,1..240] of char=(
   'endif'#010+
   #010+
   '# Where to install the examples, under linux we use the doc dir'#010+
-  '# because the co','pytree command will create a subdir itself'#010+
-  'ifndef INSTALL_EXAMPLEDIR'#010+
+  '# because the copytree command will create a subdir itself'#010+
+  'ifnd','ef INSTALL_EXAMPLEDIR'#010+
   'ifdef UNIXHier'#010+
   'ifdef INSTALL_FPCPACKAGE'#010+
   #010+
@@ -813,10 +827,10 @@ const fpcmakeini : array[0..247,1..240] of char=(
   ')/$(PACKAGE_NAME)'#010+
   'else'#010+
   'ifdef linuxHier'#010+
-  'INSTALL','_EXAMPLEDIR:=$(INSTALL_DOCDIR)/examples'#010+
+  'INSTALL_EXAMPLEDIR:=$(INSTALL_DOCDIR)/examples'#010+
   'else'#010+
-  'INSTALL_EXAMPLEDIR:=$(INSTALL_PREFIX)/doc/fpc-$(FPC_VERSION)/examples/'+
-  '$(PACKAGE_NAME)'#010+
+  'IN','STALL_EXAMPLEDIR:=$(INSTALL_PREFIX)/doc/fpc-$(FPC_VERSION)/example'+
+  's/$(PACKAGE_NAME)'#010+
   'endif'#010+
   'endif'#010+
   #010+
@@ -824,11 +838,11 @@ const fpcmakeini : array[0..247,1..240] of char=(
   #010+
   'ifdef BSDhier'#010+
   'INSTALL_EXAMPLEDIR:=$(INSTALL_PREFIX)/share/examples/$(PACKAGE_NAME)-$'+
-  '(PACKA','GE_VERSION)'#010+
+  '(PACKAGE_VERSION)'#010+
   'else'#010+
   'ifdef linuxHier'#010+
-  'INSTALL_EXAMPLEDIR:=$(INSTALL_DOCDIR)/examples/$(PACKAGE_NAME)-$(PACKA'+
-  'GE_VERSION)'#010+
+  'INSTALL_EXAMPL','EDIR:=$(INSTALL_DOCDIR)/examples/$(PACKAGE_NAME)-$(PAC'+
+  'KAGE_VERSION)'#010+
   'else'#010+
   'INSTALL_EXAMPLEDIR:=$(INSTALL_PREFIX)/doc/$(PACKAGE_NAME)-$(PACKAGE_VE'+
   'RSION)'#010+
@@ -837,8 +851,8 @@ const fpcmakeini : array[0..247,1..240] of char=(
   'endif'#010+
   'endif'#010+
   'else'#010+
-  'ifdef INSTALL_FPCPA','CKAGE'#010+
-  'INSTALL_EXAMPLEDIR:=$(INSTALL_BASEDIR)/examples/$(PACKAGE_NAME)'#010+
+  'ifdef INSTALL_FPCPACKAGE'#010+
+  'INSTALL_EXAMPLEDIR:=$(INSTALL_BASEDIR)/ex','amples/$(PACKAGE_NAME)'#010+
   'else'#010+
   'INSTALL_EXAMPLEDIR:=$(INSTALL_BASEDIR)/examples'#010+
   'endif'#010+
@@ -847,24 +861,23 @@ const fpcmakeini : array[0..247,1..240] of char=(
   #010+
   '# Where the some extra (data)files will be stored'#010+
   'ifndef INSTALL_DATADIR'#010+
-  'INSTALL_DATADIR=$(INSTALL','_BASEDIR)'#010+
+  'INSTALL_DATADIR=$(INSTALL_BASEDIR)'#010+
   'endif'#010+
   #010+
   'ifndef INSTALL_SHAREDDIR'#010+
-  'INSTALL_SHAREDDIR=$(INSTALL_PREFIX)/lib'#010+
+  'INSTA','LL_SHAREDDIR=$(INSTALL_PREFIX)/lib'#010+
   'endif'#010+
   #010+
   '#####################################################################'#010+
   '# Cross compile dirs'#010+
-  '############################################################','########'+
-  '#'#010+
+  '#####################################################################'#010+
   #010+
   'ifdef CROSSCOMPILE'#010+
-  '# Directory where the cross compile tools are stored.'#010+
+  '# Directory where',' the cross compile tools are stored.'#010+
   '# First check if they are available in FPCDIR. If no targets/ subdir'#010+
   '# is found use the targets/ subdir in INSTALL_BASEDIR.'#010+
   'ifndef CROSSBINDIR'#010+
-  'CROSSBINDIR:=','$(wildcard $(CROSSTARGETDIR)/bin/$(SOURCESUFFIX))'#010+
+  'CROSSBINDIR:=$(wildcard $(CROSSTARGETDIR)/bin/$(SOURCESUFFIX','))'#010+
   'ifeq ($(CROSSBINDIR),)'#010+
   'CROSSBINDIR:=$(wildcard $(INSTALL_BASEDIR)/cross/$(TARGETSUFFIX)/bin/$'+
   '(FULL_SOURCE))'#010+
@@ -876,20 +889,20 @@ const fpcmakeini : array[0..247,1..240] of char=(
   #010+
   #010+
   '[dirlibc]'#010+
-  '# On linux, try to find where libg','cc.a is.'#010+
+  '# On linux, try to find where libgcc.a is.'#010+
   'ifeq ($(OS_SOURCE),linux)'#010+
   #010+
-  '# Amd64 to i386?'#010+
+  '# Amd64 to ','i386?'#010+
   'ifndef GCCLIBDIR'#010+
   'ifeq ($(CPU_TARGET),i386)'#010+
   'ifneq ($(findstring x86_64,$(shell uname -a)),)'#010+
   'ifeq ($(BINUTILSPREFIX),)'#010+
   'GCCLIBDIR:=$(shell dirname `gcc -m32 -print-libgcc-file-name`)'#010+
   'endif'#010+
-  'e','ndif'#010+
+  'endif'#010+
   'endif'#010+
   'ifeq ($(CPU_TARGET),powerpc64)'#010+
-  'ifeq ($(BINUTILSPREFIX),)'#010+
+  'ifeq ','($(BINUTILSPREFIX),)'#010+
   'GCCLIBDIR:=$(shell dirname `gcc -m64 -print-libgcc-file-name`)'#010+
   'endif'#010+
   'endif'#010+
@@ -897,21 +910,21 @@ const fpcmakeini : array[0..247,1..240] of char=(
   #010+
   '# Try cross gcc'#010+
   'ifndef GCCLIBDIR'#010+
-  'CROSSGCC=$(strip $(wildcard $(addsuffix /$(BINUTILSPREFIX',')gcc$(SRCEX'+
-  'EEXT),$(SEARCHPATH))))'#010+
-  'ifneq ($(CROSSGCC),)'#010+
+  'CROSSGCC=$(strip $(wildcard $(addsuffix /$(BINUTILSPREFIX)gcc$(SRCEXEE'+
+  'XT),$(SEARCHPATH))))'#010+
+  'ifneq ($(CROS','SGCC),)'#010+
   'GCCLIBDIR:=$(shell dirname `$(CROSSGCC) -print-libgcc-file-name`)'#010+
   'endif'#010+
   'endif'#010+
   #010+
   '# Other libraries from ld.so.conf'#010+
   'ifndef OTHERLIBDIR'#010+
-  'OTHERLIBDIR:=$(shell grep -v "^\#" /etc/ld.so.conf | ','awk '#039'{ ORS='+
-  '" "; print $1 }'#039')'#010+
+  'OTHERLIBDIR:=$(shell grep -v "^\#" /etc/ld.so.conf | awk '#039'{ ORS=" '+
+  '"; print $1 }'#039')'#010+
   'endif'#010+
   'endif'#010+
   #010+
-  'ifdef inUnix'#010+
+  'ifdef',' inUnix'#010+
   'ifeq ($(OS_SOURCE),netbsd)'#010+
   'OTHERLIBDIR+=/usr/pkg/lib'#010+
   'endif'#010+
@@ -921,8 +934,9 @@ const fpcmakeini : array[0..247,1..240] of char=(
   #010+
   '[extensions]'#010+
   '#####################################################################'#010+
-  '# Default',' extensions'#010+
-  '#####################################################################'#010+
+  '# Default extensions'#010+
+  '###################################','#################################'+
+  '#'#010+
   #010+
   '# Default needed extensions (Go32v2,Linux)'#010+
   'BATCHEXT=.bat'#010+
@@ -934,9 +948,9 @@ const fpcmakeini : array[0..247,1..240] of char=(
   'LTOEXT=.bc'#010+
   'ASMEXT=.s'#010+
   'SMARTEXT=.sl'#010+
-  'STATICLI','BEXT=.a'#010+
+  'STATICLIBEXT=.a'#010+
   'SHAREDLIBEXT=.so'#010+
-  'SHAREDLIBPREFIX=libfp'#010+
+  'SHAREDLIBPREFIX=libfp'#010,
   'STATICLIBPREFIX=libp'#010+
   'IMPORTLIBPREFIX=libimp'#010+
   'RSTEXT=.rst'#010+
@@ -945,9 +959,9 @@ const fpcmakeini : array[0..247,1..240] of char=(
   '#DEBUGSYMEXT #for debugger symbol files, define only for targets which'+
   ' has this'#010+
   #010+
-  '# Go','32v1'#010+
+  '# Go32v1'#010+
   'ifeq ($(OS_TARGET),go32v1)'#010+
-  'STATICLIBPREFIX='#010+
+  'STATICLIBPREFIX','='#010+
   'SHORTSUFFIX=v1'#010+
   'endif'#010+
   #010+
@@ -963,9 +977,9 @@ const fpcmakeini : array[0..247,1..240] of char=(
   'STATICLIBPREFIX='#010+
   'OEXT=.obj'#010+
   'ASMEXT=.asm'#010+
-  'S','HAREDLIBEXT=.dll'#010+
+  'SHAREDLIBEXT=.dll'#010+
   'SHORTSUFFIX=wat'#010+
-  'IMPORTLIBPREFIX='#010+
+  'IMPORTLIBPREFI','X='#010+
   'endif'#010+
   #010+
   '# Android native'#010+
@@ -980,13 +994,13 @@ const fpcmakeini : array[0..247,1..240] of char=(
   #010+
   '# Linux'#010+
   'ifeq ($(OS_TARGET),linux)'#010+
-  'BATCHEXT=.sh'#010,
+  'BATCHEXT=.sh'#010+
   'EXEEXT='#010+
   'HASSHAREDLIB=1'#010+
   'SHORTSUFFIX=lnx'#010+
   'endif'#010+
   #010+
-  '# DragonFly BSD'#010+
+  '#',' DragonFly BSD'#010+
   'ifeq ($(OS_TARGET),dragonfly)'#010+
   'BATCHEXT=.sh'#010+
   'EXEEXT='#010+
@@ -999,12 +1013,12 @@ const fpcmakeini : array[0..247,1..240] of char=(
   'BATCHEXT=.sh'#010+
   'EXEEXT='#010+
   'HASSHAREDLIB=1'#010+
-  'SHORTSUFFIX=fbs'#010,
+  'SHORTSUFFIX=fbs'#010+
   'endif'#010+
   #010+
   '# NetBSD'#010+
   'ifeq ($(OS_TARGET),netbsd)'#010+
-  'BATCHEXT=.sh'#010+
+  'BATC','HEXT=.sh'#010+
   'EXEEXT='#010+
   'HASSHAREDLIB=1'#010+
   'SHORTSUFFIX=nbs'#010+
@@ -1020,12 +1034,12 @@ const fpcmakeini : array[0..247,1..240] of char=(
   #010+
   '# Win32'#010+
   'ifeq ($(OS_TARGET),win32)'#010+
-  'SHAREDL','IBEXT=.dll'#010+
+  'SHAREDLIBEXT=.dll'#010+
   'SHORTSUFFIX=w32'#010+
   'endif'#010+
   #010+
   '# OS/2'#010+
-  'ifeq ($(OS_TARGET),os2)'#010+
+  'ifeq (','$(OS_TARGET),os2)'#010+
   'BATCHEXT=.cmd'#010+
   'AOUTEXT=.out'#010+
   'STATICLIBPREFIX='#010+
@@ -1039,10 +1053,10 @@ const fpcmakeini : array[0..247,1..240] of char=(
   'ifeq ($(OS_TARGET),emx)'#010+
   'BATCHEXT=.cmd'#010+
   'AOUTEXT=.out'#010+
-  'STATIC','LIBPREFIX='#010+
+  'STATICLIBPREFIX='#010+
   'SHAREDLIBEXT=.dll'#010+
   'SHORTSUFFIX=emx'#010+
-  'ECHO=echo'#010+
+  'EC','HO=echo'#010+
   'IMPORTLIBPREFIX='#010+
   'endif'#010+
   #010+
@@ -1057,11 +1071,11 @@ const fpcmakeini : array[0..247,1..240] of char=(
   'ifeq ($(OS_TARGET),aros)'#010+
   'EXEEXT='#010+
   'SHAREDLIBEXT=.library'#010+
-  'SHORTSUFFIX=','aros'#010+
+  'SHORTSUFFIX=aros'#010+
   'endif'#010+
   #010+
   '# MorphOS'#010+
-  'ifeq ($(OS_TARGET),morphos)'#010+
+  'ifeq ($(OS_TARGET),morpho','s)'#010+
   'EXEEXT='#010+
   'SHAREDLIBEXT=.library'#010+
   'SHORTSUFFIX=mos'#010+
@@ -1077,12 +1091,12 @@ const fpcmakeini : array[0..247,1..240] of char=(
   'ifeq ($(OS_TARGET),beos)'#010+
   'BATCHEXT=.sh'#010+
   'EXEEXT='#010+
-  'SHORTSUFFIX=be'#010,
+  'SHORTSUFFIX=be'#010+
   'endif'#010+
   #010+
   '# Haiku'#010+
   'ifeq ($(OS_TARGET),haiku)'#010+
-  'BATCHEXT=.sh'#010+
+  'BATCHE','XT=.sh'#010+
   'EXEEXT='#010+
   'SHORTSUFFIX=hai'#010+
   'endif'#010+
@@ -1099,11 +1113,11 @@ const fpcmakeini : array[0..247,1..240] of char=(
   'BATCHEXT=.sh'#010+
   'EXEEXT='#010+
   'SHORTSUFFIX=qnx'#010+
-  'endif'#010,
+  'endif'#010+
   #010+
   '# Netware clib'#010+
   'ifeq ($(OS_TARGET),netware)'#010+
-  'EXEEXT=.nlm'#010+
+  'EXE','EXT=.nlm'#010+
   'STATICLIBPREFIX='#010+
   'SHORTSUFFIX=nw'#010+
   'IMPORTLIBPREFIX=imp'#010+
@@ -1118,10 +1132,10 @@ const fpcmakeini : array[0..247,1..240] of char=(
   'endif'#010+
   #010+
   '# MacOS'#010+
-  'i','feq ($(OS_TARGET),macos)'#010+
+  'ifeq ($(OS_TARGET),macos)'#010+
   'BATCHEXT='#010+
   'EXEEXT='#010+
-  'DEBUGSYMEXT=.xcoff'#010+
+  'DEBU','GSYMEXT=.xcoff'#010+
   'SHORTSUFFIX=mac'#010+
   'IMPORTLIBPREFIX=imp'#010+
   'endif'#010+
@@ -1133,12 +1147,12 @@ const fpcmakeini : array[0..247,1..240] of char=(
   'HASSHAREDLIB=1'#010+
   'SHORTSUFFIX=dwn'#010+
   'EXEDBGEXT=.dSYM'#010+
-  'endif',#010+
+  'endif'#010+
   #010+
   '# gba'#010+
   'ifeq ($(OS_TARGET),gba)'#010+
   'EXEEXT=.gba'#010+
-  'SHAREDLIBEXT=.so'#010+
+  'SHA','REDLIBEXT=.so'#010+
   'SHORTSUFFIX=gba'#010+
   'endif'#010+
   #010+
@@ -1151,12 +1165,12 @@ const fpcmakeini : array[0..247,1..240] of char=(
   '# NativeNT'#010+
   'ifeq ($(OS_TARGET),NativeNT)'#010+
   'SHAREDLIBEXT=.dll'#010+
-  'SHORTSUFFIX=','nativent'#010+
+  'SHORTSUFFIX=nativent'#010+
   'endif'#010+
   #010+
   '# wii'#010+
   'ifeq ($(OS_TARGET),wii)'#010+
-  'EXEEXT=.dol'#010+
+  'E','XEEXT=.dol'#010+
   'SHAREDLIBEXT=.so'#010+
   'SHORTSUFFIX=wii'#010+
   'endif'#010+
@@ -1172,12 +1186,12 @@ const fpcmakeini : array[0..247,1..240] of char=(
   '# Java'#010+
   'ifeq ($(OS_TARGET),java)'#010+
   'OEXT=.class'#010+
-  'ASMEXT=.','j'#010+
+  'ASMEXT=.j'#010+
   'SHAREDLIBEXT=.jar'#010+
   'SHORTSUFFIX=java'#010+
   'endif'#010+
   #010+
-  '# Android java'#010+
+  '# A','ndroid java'#010+
   'ifeq ($(CPU_TARGET),jvm)'#010+
   'ifeq ($(OS_TARGET),android)'#010+
   'OEXT=.class'#010+
@@ -1190,11 +1204,11 @@ const fpcmakeini : array[0..247,1..240] of char=(
   '# MS-DOS'#010+
   'ifeq ($(OS_TARGET),msdos)'#010+
   'STATICLIBPREFIX='#010+
-  'STA','TICLIBEXT=.a'#010+
+  'STATICLIBEXT=.a'#010+
   'SHORTSUFFIX=d16'#010+
   'endif'#010+
   #010+
-  '# Embedded'#010+
+  '# Embedded'#010,
   'ifeq ($(OS_TARGET),embedded)'#010+
   'ifeq ($(CPU_TARGET),i8086)'#010+
   'STATICLIBPREFIX='#010+
@@ -1208,20 +1222,20 @@ const fpcmakeini : array[0..247,1..240] of char=(
   '# Win16'#010+
   'ifeq ($(OS_TARGET),win16)'#010+
   'STATICLIBPREFIX='#010+
-  'STATICL','IBEXT=.a'#010+
+  'STATICLIBEXT=.a'#010+
   'SHAREDLIBEXT=.dll'#010+
   'SHORTSUFFIX=w16'#010+
-  'endif'#010+
+  'endi','f'#010+
   #010+
   #010+
   '# For 8.3 limited OS'#039's the short suffixes'#010+
   '# Otherwise use the full source/target names'#010+
   'ifneq ($(findstring $(OS_SOURCE),$(LIMIT83fs)),)'#010+
   'FPCMADE=fpcmade.$(SHORTSUFFIX)'#010+
-  'ZIPSUFFIX=$(SHORTSUFFI','X)'#010+
+  'ZIPSUFFIX=$(SHORTSUFFIX)'#010+
   'ZIPCROSSPREFIX='#010+
   'ZIPSOURCESUFFIX=src'#010+
-  'ZIPEXAMPLESUFFIX=exm'#010+
+  'ZIPEXAMP','LESUFFIX=exm'#010+
   'else'#010+
   'FPCMADE=fpcmade.$(TARGETSUFFIX)'#010+
   'ZIPSOURCESUFFIX=.source'#010+
